#!/usr/bin/env perl

use Gtk2 -init;
use Gtk2::GladeXML;
use File::Copy;

#my $glade_file="image_font.glade";
#取得执行文件同名的界面文件
$_=$0; s/^.*\///; s/\..*?$//; my $glade_file=$_.".glade";

my $gui = Gtk2::GladeXML->new($glade_file, 'mainwindow');
$gui->signal_autoconnect_from_package('main');

my $save = Gtk2::GladeXML->new($glade_file, 'window-saveas');
$save->signal_autoconnect_from_package('main');

my $img="$ENV{HOME}/image_font.png";
$gui->get_widget('combo-3d')->set_active(0);
$gui->get_widget('combo-shade')->set_active(0);
Gtk2->main;

############# ROUTINES #############
sub on_window1_destroy{Gtk2->main_quit;}

sub on_button_view_clicked{
#==============base
$color_base=$gui->get_widget('color-base')->get_color()->to_string;
$font=$gui->get_widget('file_font')->get_filename(); $size="120"; $input=$gui->get_widget('input')->get_text();
$cmd="convert -background none -fill \"$color_base\" -font \"$font\" -pointsize $size label:\"$input\" $img";
print "------------------------\n====> base:\t$cmd\n"; system($cmd);
#==============3D
if ($gui->get_widget('check-3d')->get_active()){
$color_3d=$gui->get_widget('color-3d')->get_color()->to_string;$effect=$gui->get_widget('combo-3d')->get_active_text();
$cmd="convert $img -matte \\( +clone -channel A -separate +channel -negate -bordercolor black -border 5  -blur 0x2 -shade 120x30 -normalize -blur 0x1  -fill \"$color_3d\" -tint 100 \\) -gravity center -compose $effect -composite $img";
print "====> 3D:\t$cmd\n"; system($cmd);
}
#==============shade
if ($gui->get_widget('check-shade')->get_active()){
$color_shade=$gui->get_widget('color-shade')->get_color()->to_string;
$cmd="convert $img \\( +clone -background \"$color_shade\" -shadow 80x4+4+4 \\) +swap -background none  -layers merge +repage $img";
print "====> shade:\t$cmd\n"; system($cmd);
}

$gui->get_widget('preview')->set_from_file($img);
}

